#pragma once

#include "Configuration.h"

class __declspec(uuid("{ADFF859D-B57C-411a-A3AD-9EB07A05A97D}")) CConfStrageDir
	: public IConfStrageDir
	, public CComObjectRoot
{
public:
	BEGIN_COM_MAP(CConfStrageDir)
		COM_INTERFACE_ENTRY(IConfStrageDir)
	END_COM_MAP( )

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct() throw();

	HRESULT Init(LPCWSTR v_pIniFilePath) throw();

	/// IConfStrageDir ///

	virtual HRESULT __stdcall OpenStrage(LPCWSTR v_pName, IConfStrage** v_ppStrage) throw();

	virtual HRESULT __stdcall EnumStrages(IConfStrageDirEnumStrages** v_ppEnumStrages) throw();

private:

	friend class CConfStrageDirEnumStrages;

	typedef CRBMap<CAtlStringW, CComPtr<IConfStrage> > CSectionMap;

	CSectionMap sectionMap_;

	CAtlStringW iniFilePath_;
};
